#include "dessiner.h"

#include <stdio.h>

void dessinerMaillageMat( Maillage *m, unsigned int N, unsigned int M )
{	
    // 1 couleur par triangle
    glShadeModel(GL_FLAT);
    
    glBegin(GL_TRIANGLES);
    // Trac par bandes de 2 triangles  chaque fois
    // Pour 4 points [i,j], [i+1,j], [i,j+1], [i+1,j+1],
    // il y a 2 triangles :
    // [i,j], [i,j+1], [i+1,j+1]
    // et [i,j], [i+1,j], [i+1,j+1]
    for( unsigned int i=0; i<N-1; i++)
    {
        for( unsigned int j=0; j<M-1; ++j)
        {
		Point p1, p2, p3, p4;
		Couleur c1, c2, c3, c4;
		
		p1 = m->points[ ind(i,j,N) ];		c1 = m->couls[ ind(i,j,N) ];
		p2 = m->points[ ind(i,j+1,N) ];		c2 = m->couls[ ind(i,j+1,N) ];
		p3 = m->points[ ind(i+1,j,N) ];		c3 = m->couls[ ind(i+1,j,N) ];
		p4 = m->points[ ind(i+1,j+1,N) ];	c4 = m->couls[ ind(i+1,j+1,N) ];
		
		// A COMPLETER
		
		// Premier triangle
		// Par dfaut, openGL remplit le triangle avec une seule couleur
		
		// Second triangle
		
		// END COMPLETER

	}
    }
    glEnd();
}


void dessinerMaillageMatStrip( Maillage *m, unsigned int N, unsigned int M )
{
    // Trac par bandes entires
    for( unsigned int i=0; i<N-1; i++)
    {
    	glBegin(GL_TRIANGLE_STRIP);
        for( unsigned int j=0; j<M; ++j)
        {
		// A COMPLETER
		// END COMPLETER

	}
	glEnd();
    }
}


void dessinerMaillageMatGouraud( Maillage *m, unsigned int N, unsigned int M )
{
	// Active le shading gouraud
	glShadeModel(GL_SMOOTH);
	
    glBegin(GL_TRIANGLES);
    // Trac par bandes de 2 triangles  chaque fois
    // Pour 4 points [i,j], [i+1,j], [i,j+1], [i+1,j+1],
    // il y a 2 triangles :
    // [i,j], [i,j+1], [i+1,j+1]
    // et [i,j], [i+1,j], [i+1,j+1]
    for( unsigned int i=0; i<N-1; i++)
    {
        for( unsigned int j=0; j<M-1; ++j)
        {
		Point p1, p2, p3, p4;
		Couleur c1, c2, c3, c4;
		
		p1 = m->points[ ind(i,j,N) ];		c1 = m->couls[ ind(i,j,N) ];
		p2 = m->points[ ind(i,j+1,N) ];		c2 = m->couls[ ind(i,j+1,N) ];
		p3 = m->points[ ind(i+1,j,N) ];		c3 = m->couls[ ind(i+1,j,N) ];
		p4 = m->points[ ind(i+1,j+1,N) ];	c4 = m->couls[ ind(i+1,j+1,N) ];

		// A COMPLETER
		// Premier triangle

		// Second triangle
	
		// END COMPLETER

	}
    }
    glEnd();
    
	// Ractive le shading simple
	glShadeModel(GL_FLAT);
}


/**
 * Dessine un maillage index
 */
void dessinerMaillage( MaillageIndexe *m, bool Gouraud )
{
	if( Gouraud )
	{
		// Active le shading gouraud
		glShadeModel(GL_SMOOTH);
	}
	else
	{
		glShadeModel(GL_FLAT);
	}
	
	glBegin(GL_TRIANGLES);
	// A COMPLETER

	// END COMPLETER
	glEnd();
}

